using System;
using Gtk;

public class MyWindow : Window {
	XmlBioSeqDocument  _docSequences;
	BioHPaned _hpaned;
	Statusbar _sb;
	
	public MyWindow () : base ("gBioSeq")
	{
		this.SetDefaultSize (400, 300);
		this.DeleteEvent += new DeleteEventHandler (OnMyWindowDelete);
		
		_docSequences = new XmlBioSeqDocument();
		
		Gtk.Toolbar tool_bar = new Toolbar();
		VBox vbox = new VBox();

		_hpaned = new BioHPaned(_docSequences);
		//_hpaned.createSequence();
		Button btn_save = new Button ("save");
		btn_save.Clicked += new EventHandler (btn_save_click);
		Button btn_load = new Button ("load");
		btn_load.Clicked += new EventHandler (btn_load_click);
		Button btn_new = new Button ("new sequence");
		btn_new.Clicked += new EventHandler (btn_new_sequence);

		tool_bar.Add(btn_load);
		tool_bar.Add(btn_save);
		tool_bar.Add(btn_new);
		vbox.PackStart(tool_bar,false,false,1);
		//vbox.PackStart(btn_load,false,false,1);
		vbox.Add(_hpaned);
		_sb = new Statusbar();
		_sb.Push (1, "truc");

		vbox.PackEnd(_sb,false,false,0);
		this.Add(vbox);
		this.ShowAll ();
		this.ReshowWithInitialSize();
		
		//_hpaned.Hdefilement.ValueChanged += new EventHandler (seq_pos_changed);

		_hpaned.Statusbar = _sb;
	}
	/*
	public void seq_pos_changed(object obj, EventArgs args) {
		  string message = String.Format ("position: {0}", _hpaned.Hdefilement.Value);
          _sb.Pop (1);
          _sb.Push (1, message);

	}
	*/
	void OnMyWindowDelete (object o, DeleteEventArgs args)
	{
		//System.Console.WriteLine("chouette" + vue.Sequence);
		//_docSequences.Save(System.Console.Out);
		Application.Quit ();
	//	System.Console.WriteLine(vue.Sequence);
	}
	
	void btn_new_sequence(object obj, System.EventArgs args) {
		_hpaned.createSequence();
		this.ShowAll ();
	}

	void btn_save_click(object obj, System.EventArgs args) {
		BioFileSelection fs = new BioFileSelection ("Choose a file");
		fs.Run ();
		//lbl.Text = "Selected: " + fs.SelectionEntry.Text;
		//System.Console.WriteLine("Selected: " + fs.Filename);
		if (fs.SelectionEntry.Text != "")  {
			_docSequences.Save(fs.Filename);
		}
		fs.Destroy ();
	}
	
	void btn_load_click(object obj, System.EventArgs args) {
		BioFileSelection fs = new BioFileSelection ("");
		fs.Run ();
		//lbl.Text = "Selected: " + fs.SelectionEntry.Text;
		if (fs.SelectionEntry.Text != "")  {
			//System.Console.WriteLine("Selected: " + fs.Filename);
		
			XmlBioSeqDocument docSequences = new XmlBioSeqDocument();
			docSequences.Load(fs.Filename);
			//docSequences.Save(System.Console.Out);
			//_hpaned = new BioHPaned(_docSequences);
			_hpaned.AddXmlSequences(docSequences);
			this.ShowAll ();
		}
		fs.Destroy ();

	}
}